//
//	(c) Paul Campbell 2012 - released under LGPL
//	This file is part of the DSPace Robot support software.
//
//	The DSPace Robot support software is free software: you can
// 	redistribute it and/or modify it under the terms of the
//	Lesser GNU General Public License as published by the Free
//	Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	The DSPace Robot support software is distributed in the hope
//	that it will be useful, but WITHOUT ANY WARRANTY; without even
//	the implied warranty of MERCHANTABILITY or FITNESS FOR A
//	PARTICULAR PURPOSE.  See the Lesser GNU General Public License
//	for more details.
//
//	You should have received a copy of the lesser GNU General Public
//	License along with the DSPace Robot support software.  If not,
//	see <http://www.gnu.org/licenses/>.
//
//
//	robot sensors for seeed parts
//

#include "seeed.h"


int
GroveIRProximitySensor::AverageValue(int n)
{
	int i;
	long l = 0;
	for (i = 0; i < n; i++)
	l += AnalogRead();
	return l/n;
}

void
GroveUltrasonicRangeSensor::Ping()
{
	PinMode(OUTPUT);
	DigitalWrite(LOW);
	delayMicroseconds(2);
	DigitalWrite(HIGH);
	delayMicroseconds(5);
	DigitalWrite(LOW);
}

void
GroveColourSensor::Enable()
{
	WriteAddress(ADDRESS, REG_TIMING, INTEG_MODE_FREE);
	WriteAddress(ADDRESS, REG_INT_SOURCE, INT_SOURCE_GREEN);
	WriteAddress(ADDRESS, REG_INT, INTR_LEVEL|INTR_PERSIST_EVERY);
	WriteAddress(ADDRESS, REG_GAIN, GAIN_1|PRESCALER_4);
	WriteAddress(ADDRESS, REG_CTL, CTL_DAT_INIITIATE);
}

void
GroveColourSensor::ReadRGB(int &red, int &green, int &blue, int &clear)
{
	unsigned char v[8];
	WriteAddress(ADDRESS, REG_BLOCK_READ);
	ReadArray(ADDRESS, &v[0], 8);
	green = (v[1]<<8)|v[0];
	red = (v[3]<<8)|v[2];
	blue = (v[5]<<8)|v[4];
	clear = (v[7]<<8)|v[6];
	WriteAddress(ADDRESS, CLR_INT);
}
